//Surdefinition de l'oprateur <<
ostream &operator<<(ostream &_os,const Point &pnt) {
  _os << pnt.Poids << " table ";
  _os << pnt.X<<" "<<pnt.Y<<endl;
  return _os;
}

//Surdefinition de l'oprateur <
int operator < (Point p1 ,Point p2){
	if(p1.Poids<p2.Poids)
		return 1;
	else
		return 0;
}

#ifndef CHEMIN_FLAG
#define CHEMIN_FLAG

/*
//Variable Global
extern	int		Chemin[dimension][dimension];	   //Tableau contenant les chemins
	int		Map[dimension+2][dimension+2];

	//Variable Normalis (C'est a dire entiere, trouver en divant par dimension)

	int     Robot_Vitesse_G = 0;			       //Vitesse de la Roue Gauche du Robot
	int     Robot_Vitesse_D = 0;                   //Vitesse de la Roue Droite du Robot
	int     Robot_X = 0;						   //Position X du robot
	int		Robot_Y = 0;						   //Position Y du robot
	int     Robot_Arrive_X = 0;						   //Position d'arrive X
	int     Robot_Arrive_Y = 0;						   //Position d'arrive Y	
	int     Robot_Stop	   = 1;                   //Stop la thread (0 = Stop)
	Liste<Point>  Robot_Chemin;						//Chemin du Robot

	//Semaphore
	CSemaphore    Sem_Vitesse;					//Semaphore pour les vitesse
	CSemaphore    Sem_Position;					//Semaphore pour la position du robt
	CSemaphore    Sem_Arrive;					//Semaphore pour la position d'arrivee


	int     m_Vitesse_g = 0;				   //Vitesse Gauche
	int     m_Vitesse_d = 0;				   //Vitesse Droite
	int     m_Passe_x	= 0;						   //Point X  
	int     m_Passe_y	= 0;						   //Point Y  


	int     m_Depart_x  = 0; 				   //Nouveau Point de dpart en X
	int     m_Depart_y  = 0;                   //Nouveau Point de dpart en Y
	int     m_Arrive_x  = 0;	    		   //Point d'arrive en X
	int     m_Arrive_y  = 0;                   //Point d'arrive en Y
	int     m_Dir_Fut   = 0;                   //Direction Future du Robot
	int     m_Dir_Pre   = 0;                   //Direction Present du Robot
	int     m_Dir_Pas   = 0;                   //Direction Pass Robot
	int		m_Odo_x		= 0;				   //Odomtrie en x	
	int		m_Odo_y     = 0;				   //Odomtrie en y	
*/
#endif

void Initialisation(){
	int		i,j;				

	//initialize le tableau  Zro        //Map 
	for(i=0;i<dimension+2;i++)				//Zro = rien   
	{						  				//Un = Obstacle 
		for(j=0;j<dimension+2;j++)		    //Deux = Depart
		{								    //Trois = Arrive
			Map[i][j]=0;				  
		}
	}
	//Simule un obstacle tout au tour de la Map
	for(i=0;i<dimension+2;i++)
		{
			Map[i][0]=1;
			Map[i][dimension+1]=1;
			Map[0][i]=1;
			Map[dimension+1][i]=1;
		}

}



//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Trouve_Direction()
//  Date: 26/09/98
//  Description: Trouve le chemin optimum dans 
//               un terrain truff d'obstacles.
//////////////////////////////////////////////////////////////////////////////

void Trouve_Chemin(int Depart_x, int Depart_y, int Arrive_x, int Arrive_y){
	/////////////////////////////////////////////////////////////////
    //Variable nessaire pour la fonction
	/////////////////////////////////////////////////////////////////

	MonceauBin<Point>	Monceau;               //Liste des points  traiter
	Point				Temp_Point;            //Point temporaire 
	Point			    Courant_Point;		   //Point courant
	int		i,j;				
	int		Trouver=0;						   //Sera mis a un lorsque le chemin sera trouv
	int     pos_X = Arrive_x ;			
	int     pos_Y = Arrive_y ;

	/////////////////////////////////////////////////////////////////
	//Initialise le point courant au point de dpart
	/////////////////////////////////////////////////////////////////
	Courant_Point.X = Depart_x;
	Courant_Point.Y = Depart_y ;	
	Courant_Point.Poids = 0;
	Courant_Point.Direction = 0;		

	/////////////////////////////////////////////////////////////////
	//initialise les tableaux  Zro     
	/////////////////////////////////////////////////////////////////
	for(i=0;i<dimension;i++)			
	{						  			
		for(j=0;j<dimension;j++)		  //Chemin 
		{								    //   8  1  2
			            				    //    \ | /
										    //  7 - 0 - 3
			Chemin[i][j]=-1;                //	  /	| \
										    //   6  5  4
		}
	}

	/////////////////////////////////////////////////////////////////
	//Boucler tant que l'on n'a pas trouver le chemin
	/////////////////////////////////////////////////////////////////
	while(Trouver!=1)
	{
		/////////////////////////////////////////////////////////////////
		//Inscription du chemin du point courant
		/////////////////////////////////////////////////////////////////
		Chemin[Courant_Point.Y][Courant_Point.X]=Courant_Point.Direction;

		/////////////////////////////////////////////////////////////////
		//Vrification si on a trouv le chemin ou si l'on doit continuer
		/////////////////////////////////////////////////////////////////
		if(Courant_Point.X==Arrive_x&&Courant_Point.Y==Arrive_y)
			Trouver=1;
			
		/////////////////////////////////////////////////////////////////
		//Insersion des points entourant le point courant dans le monceau
		/////////////////////////////////////////////////////////////////
		
		// la position 1
		if(Map[Courant_Point.Y][Courant_Point.X+1]==0)
		{
			if(Chemin[Courant_Point.Y-1][Courant_Point.X]==-1)
			{
				Temp_Point.Poids=Courant_Point.Poids + POIDS_DROITE;
				Temp_Point.Direction = 1;
				Temp_Point.X=Courant_Point.X;
				Temp_Point.Y=Courant_Point.Y-1;
				Monceau.Entasser(Temp_Point);
			}
		}

		// la position 2
		if(Map[Courant_Point.Y][Courant_Point.X+2]==0)
		{
			if(Chemin[Courant_Point.Y-1][Courant_Point.X+1]==-1)
			{
				if(Map[Courant_Point.Y][Courant_Point.X+1]==0||Map[Courant_Point.Y+1][Courant_Point.X+2]==0)
				{
					Temp_Point.Poids=Courant_Point.Poids + POIDS_DIAGONALE;
					Temp_Point.Direction = 2;
					Temp_Point.X=Courant_Point.X+1;
					Temp_Point.Y=Courant_Point.Y-1;
					Monceau.Entasser(Temp_Point);
				}
			}
		}

		// la position 3
		if(Map[Courant_Point.Y+1][Courant_Point.X+2]==0)
		{
			if(Chemin[Courant_Point.Y][Courant_Point.X+1]==-1)
			{
				Temp_Point.Poids=Courant_Point.Poids + POIDS_DROITE;
				Temp_Point.Direction = 3;
				Temp_Point.X=Courant_Point.X+1;
				Temp_Point.Y=Courant_Point.Y;
				Monceau.Entasser(Temp_Point);
			}
		}

		// la position 4
		if(Map[Courant_Point.Y+2][Courant_Point.X+2]==0)
		{
			if(Chemin[Courant_Point.Y+1][Courant_Point.X+1]==-1)
			{
				if(Map[Courant_Point.Y+2][Courant_Point.X+1]==0||Map[Courant_Point.Y+1][Courant_Point.X+2]==0)
				{
					Temp_Point.Poids=Courant_Point.Poids + POIDS_DIAGONALE;
					Temp_Point.Direction = 4;
					Temp_Point.X=Courant_Point.X+1;
					Temp_Point.Y=Courant_Point.Y+1;
					Monceau.Entasser(Temp_Point);
				}
			}
		}

		// la position 5
		if(Map[Courant_Point.Y+2][Courant_Point.X+1]==0)
		{
			if(Chemin[Courant_Point.Y+1][Courant_Point.X]==-1)
			{
				Temp_Point.Poids=Courant_Point.Poids + POIDS_DROITE;
				Temp_Point.Direction = 5;
				Temp_Point.X=Courant_Point.X;
				Temp_Point.Y=Courant_Point.Y+1;
				Monceau.Entasser(Temp_Point);
			}
		}


		// la position 6
		if(Map[Courant_Point.Y+2][Courant_Point.X]==0)
		{
			if(Chemin[Courant_Point.Y+1][Courant_Point.X-1]==-1)
			{
				if(Map[Courant_Point.Y+2][Courant_Point.X+1]==0||Map[Courant_Point.Y+1][Courant_Point.X]==0)
				{
					Temp_Point.Poids=Courant_Point.Poids + POIDS_DIAGONALE;
					Temp_Point.Direction = 6;
					Temp_Point.X=Courant_Point.X-1;
					Temp_Point.Y=Courant_Point.Y+1;
					Monceau.Entasser(Temp_Point);
				}
			}
		}

		// la position 7
		if(Map[Courant_Point.Y+1][Courant_Point.X]==0)
		{
			if(Chemin[Courant_Point.Y][Courant_Point.X-1]==-1)
			{
				Temp_Point.Poids=Courant_Point.Poids + POIDS_DROITE;
				Temp_Point.Direction = 7;
				Temp_Point.X=Courant_Point.X-1;
				Temp_Point.Y=Courant_Point.Y;
				Monceau.Entasser(Temp_Point);
			}
		}

		// la position 8
		if(Map[Courant_Point.Y][Courant_Point.X]==0)
		{
			if(Chemin[Courant_Point.Y-1][Courant_Point.X-1]==-1)
			{
				if(Map[Courant_Point.Y+1][Courant_Point.X]==0||Map[Courant_Point.Y][Courant_Point.X+1]==0)
				{
					Temp_Point.Poids=Courant_Point.Poids + POIDS_DIAGONALE;
					Temp_Point.Direction = 8;
					Temp_Point.X=Courant_Point.X-1;
					Temp_Point.Y=Courant_Point.Y-1;
					Monceau.Entasser(Temp_Point);
				}
			}
		}



		/////////////////////////////////////////////////////////////////
		//Retirer le point avec le plus petit poids du monceau
		/////////////////////////////////////////////////////////////////
		i=0;
		while(i==0&&Trouver!=1)
		{
			if(Monceau.NbElements()!=0)
			{
				Monceau.RetirerMin(Courant_Point);
				if(Chemin[Courant_Point.Y][Courant_Point.X]==-1)
				{
					i=1;
				}
			}
			else //Pas de chemin Possible
			{
				Trouver=1;

				//METTRE UNE SMAPHORE
				Sem_Vitesse.Lock();
				Robot_Vitesse_G = Robot_Vitesse_D = 0;
				Sem_Vitesse.Unlock();
				cMap->m_ubiView->ShowCopSpeed();
				//cMap->m_ubiView->SendSpeed(Robot_Vitesse_G,Robot_Vitesse_D );

				m_Vitesse_g = m_Vitesse_d = 0;
				m_Dir_Pre = 0;
			
			
			
			}
		}
	}//Fin du while

	/////////////////////////////////////////////////////////////////
	//Trouver la premire direction du robot
	/////////////////////////////////////////////////////////////////
	Sem_Liste.Lock();
	Robot_Chemin.Vider();
	while(Chemin[pos_Y][pos_X]!=0&&Chemin[pos_Y][pos_X]!=-1)
	{
		Temp_Point.X = pos_X;
		Temp_Point.Y = pos_Y;
		Temp_Point.Direction = Chemin[pos_Y][pos_X];
		Robot_Chemin.Inserer(Temp_Point);
		m_Dir_Fut  = m_Dir_Pre;
		m_Dir_Pre  = Chemin[pos_Y][pos_X];
		switch(Chemin[pos_Y][pos_X])
		{
			case 1:
				pos_Y++;			
			break;
			case 2:
				pos_Y++;
				pos_X--;
			break;
			case 3:
				pos_X--;
			break;
			case 4:
				pos_Y--;
				pos_X--;
			break;
			case 5:
				pos_Y--;				
			break;
			case 6:
				pos_Y--;
				pos_X++;
			break;
			case 7:				
				pos_X++;
			break;
			case 8:
				pos_Y++;
				pos_X++;
			break;
		}
	}
	Sem_Liste.Unlock();

	if(m_Dir_Pre != 0 || flag_showmap == 0)
	{
		cMap->ShowMap();
		if(m_Dir_Pre == 0)
			flag_showmap = 1;
		else
			flag_showmap = 0;
	}

	obstacle_flag = FALSE;


}



//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Trouve_Direction()
//  Date: 27/09/98
//  Description: Trouve la Direction du Robot.
//////////////////////////////////////////////////////////////////////////////
void Trouve_Direction(){

//variable local
double teta, 
	   diff_x,
	   diff_y;
		
	Sem_Position.Lock();
	diff_x = m_Robot_Pre_X-m_Robot_Pas_X;
	diff_y = m_Robot_Pre_Y-m_Robot_Pas_Y;
	Sem_Position.Unlock();


	teta = atan2( diff_y, diff_x );
	teta = teta*180/3.14159;

	if(diff_y < 0)
		teta+=360;

	if(!(diff_x ==0 && diff_y == 0))
	{
		if(teta<112.5 && teta > 67.5){m_Dir_Pas=5;}
		if(teta<67.5 && teta > 22.5){m_Dir_Pas=4;}
		if(teta<22.5 || teta > 337.5){m_Dir_Pas=3;}
		if(teta<337.5 && teta > 292.5){m_Dir_Pas=2;}
		if(teta<292.5 && teta > 247.5){m_Dir_Pas=1;}
		if(teta<247.5 && teta > 202.5){m_Dir_Pas=8;}
		if(teta<202.5 && teta > 157.5){m_Dir_Pas=7;}
		if(teta<157.5 && teta > 112.5){m_Dir_Pas=6;}
	}
}

//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Tourne()
//  Date: 27/09/98
//  Description: Fait tourner le Robot sur place.
//////////////////////////////////////////////////////////////////////////////
void Tourne(int Degre){

	int flag = 1;
	rotation_flag = TRUE;
	Robot_Rotation = 0;

	//METTRE UNE SEMAPHORE
	Sem_Vitesse.Lock();
	Robot_Vitesse_G = 0; //On arrete car ca tourne trop rapidement
	Robot_Vitesse_D = 0;	
	Sem_Vitesse.Unlock();
	switch(Degre)
	{
	case 0:
		Robot_Rotation = 0;
		break;
	case 90:
		Robot_Rotation = 1;
//		Sem_Vitesse.Lock();
//		Robot_Vitesse_G = 2; //On arrete car ca tourne trop rapidement
//		Robot_Vitesse_D = 1;	
//		Sem_Vitesse.Unlock();
		break;
	case 135:
		Robot_Rotation = 2;
//		Sem_Vitesse.Lock();
//		Robot_Vitesse_G = 2; //On arrete car ca tourne trop rapidement
//		Robot_Vitesse_D = 1;	
//		Sem_Vitesse.Unlock();

		break;
	case 180:
		Robot_Rotation = 3;
//		Sem_Vitesse.Lock();
//		Robot_Vitesse_G = 3; //On arrete car ca tourne trop rapidement
//		Robot_Vitesse_D = 1;	
//		Sem_Vitesse.Unlock();
		break;
	case -135:
		Robot_Rotation = 4;
//		Sem_Vitesse.Lock();
//		Robot_Vitesse_G = 1; //On arrete car ca tourne trop rapidement
//		Robot_Vitesse_D = 2;	
//		Sem_Vitesse.Unlock();
		break;
	case -90:
		Robot_Rotation = 5;
//		Sem_Vitesse.Lock();
//		Robot_Vitesse_G = 1; //On arrete car ca tourne trop rapidement
//		Robot_Vitesse_D = 2;	
//		Sem_Vitesse.Unlock();
		break;
	default:
		Robot_Rotation = 0;
		break;
	}
	//Degre = 0      -> ne fait Rien
	//Degre = 90     -> 90 degre droite
	//Degre = -90    -> 90 degre gauche
	//Degre = 135    -> 180 degre droite
	//Degre = -135   -> 180 degre gauche
	//Degre = 180    -> 180 degre droite
	//Degre = -180   -> 180 degre gauche (facultatif)
	while(flag && !simflag)
	{
	if(rotation_flag==FALSE)
		{
		flag=0;
		Robot_Rotation = 0;
		}
	}
}


//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Verifie_Orientation()
//  Date: 27/09/98
//  Description: Verifie l'orientation du Robot et apporte des correctifs.
//////////////////////////////////////////////////////////////////////////////
void Verifie_Orientation(){
	/////////////////////////////////////////////////////////////////
    //Variable nessaire pour la fonction
	/////////////////////////////////////////////////////////////////
	int Diff_Dir = m_Dir_Pre - m_Dir_Pas;
	
	/////////////////////////////////////////////////////////////////
    //Oriente le Robot dans la bonne direction
	/////////////////////////////////////////////////////////////////
	//180


	if(Diff_Dir == 4 || Diff_Dir == -4)
	{
		switch(m_Dir_Pas)
		{
		case 1:
			m_Dir_Pas = 5;
			break;
		case 2:
			m_Dir_Pas = 6;
			break;
		case 3:
			m_Dir_Pas = 7;
			break;
		case 4:
			m_Dir_Pas = 8;
			break;
		case 5:
			m_Dir_Pas = 1;
			break;
		case 6:
			m_Dir_Pas = 2;
			break;
		case 7:
			m_Dir_Pas = 3;
			break;
		case 8:
			m_Dir_Pas = 4;
			break;
		}
		Beep(100,100);
		Beep(100,100);
		Tourne(180);
	}//90
	if(Diff_Dir == 2 || Diff_Dir ==  -6)
	{
		Beep(200,200);
		m_Dir_Pas +=2;
 		Tourne(90);
	}//-90
	if(Diff_Dir == -2 || Diff_Dir ==  6)
	{
		Beep(200,200);
		m_Dir_Pas -=2;
		Tourne(-90);
	}//135
	if(Diff_Dir == 3 || Diff_Dir ==  -5)
	{
		Beep(200,200);
		m_Dir_Pas +=3;
 		Tourne(135);
	}//-135
	if(Diff_Dir == -3 || Diff_Dir ==  5)
	{
		Beep(200,200);
		m_Dir_Pas -=3;
		Tourne(-135);
	}
	
	switch(m_Dir_Pas)
	{
		case 9:
			m_Dir_Pas=1;
		break;
		case 10:
			m_Dir_Pas=2;
		break;
		case 11:
			m_Dir_Pas=3;
		break;
		case 0:
			m_Dir_Pas=8;
		break;
		case -1:
			m_Dir_Pas=7;
		break;
		case -2:
			m_Dir_Pas=6;
		break;
	}
}

//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Trouve_Odomtrie()
//  Date: 29/09/98
//  Description: Trouve la postion grace  l'odomtrie.
//////////////////////////////////////////////////////////////////////////////
void Trouve_Odometrie(){

	//Si le Robot avance
	if(m_Vitesse_g != 0 || m_Vitesse_d!=0)
	{
		switch(m_Dir_Pas)
		{
			case 1:
				m_Odo_x = 0;
				m_Odo_y = -ODOm_Passe_y;
			break;
			case 2:
				m_Odo_x = ODOm_Passe_x;
				m_Odo_y = -ODOm_Passe_y;
			break;
			case 3:
				m_Odo_x = ODOm_Passe_x;
				m_Odo_y = 0;
			break;
			case 4:
				m_Odo_x = ODOm_Passe_x;
				m_Odo_y = ODOm_Passe_y;
			break;
			case 5:
				m_Odo_x = 0;
				m_Odo_y = ODOm_Passe_y;
			break;
			case 6:
				m_Odo_x = -ODOm_Passe_x;
				m_Odo_y = ODOm_Passe_y;
			break;
			case 7:
				m_Odo_x = -ODOm_Passe_x;
				m_Odo_y = 0;
			break;
			case 8:
				m_Odo_x = -ODOm_Passe_x;
				m_Odo_y = -ODOm_Passe_y;
			break;
		}
	}
	else //Si le Robot n'avance pas
	{
		m_Odo_x = 0;
		m_Odo_y = 0;
	}

}

//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Trouve_Vitesse()
//  Date: 29/09/98
//  Description: Trouve la Vitesse du Robot.
//////////////////////////////////////////////////////////////////////////////
void Trouve_Vitesse(){
	/////////////////////////////////////////////////////////////////
    //Variable nessaire pour la fonction
	/////////////////////////////////////////////////////////////////
	int Diff1 = 0;
	int Diff2 = 0;

	Diff1 = m_Dir_Pas - m_Dir_Pre;
	Diff2 = m_Dir_Pre - m_Dir_Fut;

	if(Diff1 == -7)
		Diff1 = 1;
	if(Diff1 == 7)
		Diff1 = -1;
	if(Diff2 == -7)
		Diff2 = 1;
	if(Diff2 == 7)
		Diff2 = -1;

	if(Diff1<0 && Diff2<0)
	{							//		  _
//		m_Vitesse_g = 3;		//   /\  /   
//		m_Vitesse_d = 1;        //   |  |
		m_Vitesse_g = 3;		//   /\  /   
		m_Vitesse_d = 2;        //   |  |

	}
	if(Diff1<0 && Diff2==0)
	{							//	  /	  
//		m_Vitesse_g = 2;		//   /  
//		m_Vitesse_d = 1;        //   |  
		m_Vitesse_g = 3;		//   /  
		m_Vitesse_d = 2;        //   |  

	}
	if(Diff1==0 && Diff2!=0)
	{							//	\ /
//		m_Vitesse_g = 2;		//   | 
//		m_Vitesse_d = 2;        //   |		
		m_Vitesse_g = 3;		//   | 
		m_Vitesse_d = 3;        //   |		

	}
	if(Diff1==0 && Diff2==0)
	{							//	 |
//		m_Vitesse_g = 3;		//   |   
//		m_Vitesse_d = 3;        //   |
		m_Vitesse_g = 3;		//   |   
		m_Vitesse_d = 3;        //   |

	}
	if(Diff1>0 && Diff2>0)
	{							//	_	  
//		m_Vitesse_g = 1;		//   \ /\  
//		m_Vitesse_d = 3;        //   |  |
		m_Vitesse_g = 2;		//   \ /\  
		m_Vitesse_d = 3;        //   |  |

	}
	if(Diff1>0 && Diff2==0)
	{							//	\	  
//		m_Vitesse_g = 1;		//   \     
//		m_Vitesse_d = 2;        //   |  
		m_Vitesse_g = 2;		//   \     
		m_Vitesse_d = 3;        //   |  

	}
	if(Diff1<0 && Diff2>0)
	{							//	   _    |
//		m_Vitesse_g = 2;		//    /    /
//		m_Vitesse_d = 1;        //   |    |
		m_Vitesse_g = 3;		//    /    /
		m_Vitesse_d = 2;        //   |    |

	}
	if(Diff1>0 && Diff2<0)
	{							//	|	/
//		m_Vitesse_g = 1;		//   \  \   
//		m_Vitesse_d = 2;        //   |  |
		m_Vitesse_g = 2;		//   \  \   
		m_Vitesse_d = 3;        //   |  |

	}

	if(m_Dir_Pre == 0)  //Pas de direction possible
	{
		m_Vitesse_g = 0;		
		m_Vitesse_d = 0;        

	}

}


//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Algo_Chemin()
//  Date: 27/09/98
//  Description: Thread qui s'occupe du chemin
//////////////////////////////////////////////////////////////////////////////
UINT Algo_Chemin(LPVOID pParam){
	/////////////////////////////////////////////////////////////////
    //Variable nessaire pour la fonction
	/////////////////////////////////////////////////////////////////
	int i,
		m_Target_Pas_x,
		m_Target_Pas_y,
		flag_affiche = 0,			//Pour ne pas faire l'affichage plusieurs fois pour rien
		flag_orientation = 0;		//Pour savoir si l'on connait l'orientation du robot
	double	m_Pre_x = 0,
			m_Pre_y = 0;

	while(Robot_Stop==1) //Si m_Stop == 0, La thread se termine
	{

		//METTRE UNE SMAPHORE
		Sem_Arrive.Lock();
		m_Arrive_x = Robot_Arrive_X;
		m_Arrive_y = Robot_Arrive_Y;
		Sem_Arrive.Unlock();

		//Garde le dernier point sur lequel on a fait nos calcul
		m_Passe_x = m_Depart_x;
		m_Passe_y = m_Depart_y;
		m_Robot_Pas_X = m_Pre_x;
		m_Robot_Pas_Y = m_Pre_y;


		//METTRE UNE SMAPHORE
		Sem_Position.Lock();
		m_Depart_x = Robot_X;
		m_Depart_y = Robot_Y;
		m_Pre_x = m_Robot_Pre_X;
		m_Pre_y = m_Robot_Pre_Y;
		Sem_Position.Unlock();

		
	    //Le Robot est dej  la postion d'arrive
		if(m_Depart_x==m_Arrive_x&&m_Depart_y==m_Arrive_y || !target_flag )
		{
			//METTRE UNE SMAPHORE
			Sem_Vitesse.Lock();
			Robot_Vitesse_G = Robot_Vitesse_D = 0;
			Sem_Vitesse.Unlock();
			if(flag_affiche==0)
			{
				cMap->m_ubiView->ShowCopSpeed();
				//cMap->m_ubiView->SendSpeed(Robot_Vitesse_G,Robot_Vitesse_D );
				flag_affiche=1;
			}
			
		}
		else //Le Robot doit aller  la position d'arrive
		{
			flag_affiche = 0;
			target_flag = TRUE;
			//Trouve l'orientation initial du Robot
			if(m_Dir_Pas==0)
			{
				//Trouve Dir_Pre et Dir_Fut
				Trouve_Chemin(m_Depart_x, m_Depart_y, m_Arrive_x, m_Arrive_y);

				if(m_Dir_Pre!=0)//Chemin Possible
				{

					//METTRE UNE SMAPHORE
					Sem_Position.Lock();
					m_Passe_x = Robot_X;
					m_Passe_y = Robot_Y;
					m_Robot_Pas_X = m_Robot_Pre_X;
					m_Robot_Pas_Y = m_Robot_Pre_Y;
					Sem_Position.Unlock();
				
					//METTRE UNE SMAPHORE
					Sem_Vitesse.Lock();
					Robot_Vitesse_G = Robot_Vitesse_D = 2;
					Sem_Vitesse.Unlock();
					cMap->m_ubiView->ShowCopSpeed();
					//cMap->m_ubiView->SendSpeed(Robot_Vitesse_G,Robot_Vitesse_D );
					

					//Attendre que la position change
					i = 1;
					while(i==1) 
					{
						//METTRE UNE SMAPHORE
						Sem_Position.Lock();
						m_Depart_x = Robot_X;
						m_Depart_y = Robot_Y;
						m_Pre_x = m_Robot_Pre_X;
						m_Pre_y = m_Robot_Pre_Y;
						Sem_Position.Unlock();

						if(m_Passe_x!=m_Depart_x||m_Passe_y!=m_Depart_y)
						{
							i = 0;
							flag_orientation = 1;
						}
						//METTRE UNE SMAPHORE
						Sem_Arrive.Lock();
						m_Arrive_x = Robot_Arrive_X;
						m_Arrive_y = Robot_Arrive_Y;
						Sem_Arrive.Unlock();

						if(m_Arrive_x!=m_Target_Pas_x||m_Arrive_y!=m_Target_Pas_y || obstacle_flag == TRUE)
						{
							i = 0;
						}
					}			 
					//METTRE UNE SMAPHORE
					Sem_Vitesse.Lock();
					Robot_Vitesse_G = Robot_Vitesse_D = 0;
					Sem_Vitesse.Unlock();
					cMap->m_ubiView->ShowCopSpeed();
					//cMap->m_ubiView->SendSpeed(Robot_Vitesse_G,Robot_Vitesse_D );
					

					m_Vitesse_g = m_Vitesse_d = 0;

					//Trouve Dir_Pre et Dir_Fut
					Trouve_Chemin(m_Depart_x, m_Depart_y, m_Arrive_x, m_Arrive_y);
					
					//Si l'on connait l'orientation du robot
					if(flag_orientation == 1)
					{
						//Trouve Dir_Pas			
						Trouve_Direction();
					
						// Vrifie et ajuste l'orientation du Robot s'il y a lieu				
						Verifie_Orientation();
					}


					//Garde le dernier point sur lequel on a fait nos calcul
					m_Robot_Pas_X = m_Pre_x;
					m_Robot_Pas_Y = m_Pre_y;
					m_Passe_x = m_Depart_x;
					m_Passe_y = m_Depart_y;
					m_Target_Pas_x = m_Arrive_x;
					m_Target_Pas_y = m_Arrive_y;

				}
			}

			if(m_Vitesse_g ==0 && m_Vitesse_d == 0)
			{
					//METTRE UNE SMAPHORE
					Sem_Position.Lock();
					m_Depart_x = Robot_X;
					m_Depart_y = Robot_Y;
					m_Pre_x = m_Robot_Pre_X;
					m_Pre_y = m_Robot_Pre_Y;
					Sem_Position.Unlock();
			}
			else
			{
		
				//Attendre que la position change
				i = 1;
				while(i==1) 
				{
					//METTRE UNE SMAPHORE
					Sem_Position.Lock();
					m_Depart_x = Robot_X;
					m_Depart_y = Robot_Y;
					m_Pre_x = m_Robot_Pre_X;
					m_Pre_y = m_Robot_Pre_Y;
					Sem_Position.Unlock();

					if(m_Passe_x!=m_Depart_x||m_Passe_y!=m_Depart_y)		
						i = 0;

					//METTRE UNE SMAPHORE
					Sem_Arrive.Lock();
					m_Arrive_x = Robot_Arrive_X;
					m_Arrive_y = Robot_Arrive_Y;
					Sem_Arrive.Unlock();

					if(m_Arrive_x!=m_Target_Pas_x||m_Arrive_y!=m_Target_Pas_y)
						i = 0;
					if(obstacle_flag == TRUE)
						i = 0;
				}			 
			}


			//Permet de trouver l'emplacement future du Robot 
//			Trouve_Odometrie();  	

			//Trouve Dir_Pre et Dir_Fut
			Trouve_Chemin(m_Depart_x+m_Odo_x, m_Depart_y+m_Odo_y, m_Arrive_x, m_Arrive_y);

			if(m_Dir_Pas!=0 && flag_orientation==0)
			{
				//Verifie Dir_Pas
				Trouve_Direction();

				//Vrifie et ajuste l'orientation du Robot s'il y a lieu			
				Verifie_Orientation();
			}
			flag_orientation = 0;

			//Trouve la vitesse de chaque Roue du Robot
			Trouve_Vitesse();

			//METTRE UNE SMAPHORE
			Sem_Vitesse.Lock();
			Robot_Vitesse_G = m_Vitesse_g;
			Robot_Vitesse_D = m_Vitesse_d;
			Sem_Vitesse.Unlock();
			cMap->m_ubiView->ShowCopSpeed();
			//cMap->m_ubiView->SendSpeed(Robot_Vitesse_G,Robot_Vitesse_D );
			
			
			m_Target_Pas_x = m_Arrive_x ;
			m_Target_Pas_y = m_Arrive_y ;		
		}
	}

	return 0;
}


UINT Simulation(LPVOID param)
{
	if(!target_flag)
		return 0;
	CUBIView* view = (CUBIView*)param;
	int i;
	while(simflag)
	{
		i = Robot_Chemin.NbElements();
		if(i >= 1) 
		{
			Sem_Position.Lock();
			Sem_Liste.Lock();
			Cop.x = Robot_Chemin[i-1].X*(500/dimension);
			Cop.y = Robot_Chemin[i-1].Y*(500/dimension);
			Sem_Liste.Unlock();
			m_Robot_Pre_X = Cop.x;
			m_Robot_Pre_Y = Cop.y;
			// Position dans la matrice
			Robot_X = (Cop.x - (Cop.x%(500/dimension)))/(500/dimension);
			Robot_Y = (Cop.y - (Cop.y%(500/dimension)))/(500/dimension);
			Sem_Position.Unlock();
		}
		Sleep(1500);
		if(i == 1)
			return 1;
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Ajouter_Obstacle()
//  Date: 14/11/98
//  Description: Ajoute des obstacles physiques
//////////////////////////////////////////////////////////////////////////////
void Ajouter_Obstacle(int y, int x){
	flag_changement=1;
	obstacle_flag = TRUE;

	//x++;
	//y++;

	Map[y][x] = 3;
	if(Map[y-1][x-1]==0)
		Map[y-1][x-1]=2;
	if(Map[y-1][x]==0)
		Map[y-1][x]=2;
	if(Map[y-1][x+1]==0)
		Map[y-1][x+1]=2;
	if(Map[y][x-1]==0)
		Map[y][x-1]=2;
	if(Map[y][x]==0)
		Map[y][x]=2;
	if(Map[y][x+1]==0)
		Map[y][x+1]=2;
	if(Map[y+1][x-1]==0)
		Map[y+1][x-1]=2;
	if(Map[y+1][x]==0)
		Map[y+1][x]=2;
	if(Map[y+1][x+1]==0)
		Map[y+1][x+1]=2;				
}

//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Efface_Obstacle()
//  Date: 14/11/98
//  Description:  Efface les obstacles physiques
//////////////////////////////////////////////////////////////////////////////
void Efface_Obstacle(int y, int x){
	flag_changement=1;
	obstacle_flag = TRUE;
	
	if((Map[y-1][x-1]==2||Map[y-1][x-1]==0)
		&&(Map[y-1][x]==2||Map[y-1][x]==0)
		&&(Map[y-1][x+1]==2||Map[y-1][x+1]==0)
		&&(Map[y][x+1]==2||Map[y][x+1]==0)
		&&(Map[y+1][x+1]==2||Map[y+1][x+1]==0)
		&&(Map[y+1][x]==2||Map[y+1][x]==0)
		&&(Map[y+1][x-1]==2||Map[y+1][x-1]==0)
		&&(Map[y][x-1]==2||Map[y][x-1]==0))
	{			
		Map[y][x] = 0;
	}
	else
	{
		Map[y][x] = 2;
	}

	if(Map[y-1][x-1]==2)
	{
		if((Map[y][x-1]==2||Map[y][x-1]==0)
			&&(Map[y][x-2]==2||Map[y][x-2]==0)
			&&(Map[y-1][x-2]==2||Map[y-1][x-2]==0)
			&&(Map[y-2][x-2]==2||Map[y-2][x-2]==0)
			&&(Map[y-2][x-1]==2||Map[y-2][x-1]==0)
			&&(Map[y-2][x]==2||Map[y-2][x]==0)
			&&(Map[y-1][x]==2||Map[y-1][x]==0))
		{
			Map[y-1][x-1]=0;
		}

	}

	if(Map[y-1][x]==2)
	{
		if((Map[y][x-1]==2||Map[y][x-1]==0)
			&&(Map[y-1][x-1]==2||Map[y-1][x-1]==0)
			&&(Map[y-2][x-1]==2||Map[y-2][x-1]==0)
			&&(Map[y-2][x]==2||Map[y-2][x]==0)
			&&(Map[y-2][x+1]==2||Map[y-2][x+1]==0)
			&&(Map[y-1][x+1]==2||Map[y-1][x+1]==0)
			&&(Map[y][x+1]==2||Map[y][x+1]==0))
		{
			Map[y-1][x]=0;
		}
	}
	
	if(Map[y-1][x+1]==2)
	{
		if((Map[y-1][x]==2||Map[y-1][x]==0)
			&&(Map[y-2][x]==2||Map[y-2][x]==0)
			&&(Map[y-2][x+1]==2||Map[y-2][x+1]==0)
			&&(Map[y-2][x+2]==2||Map[y-2][x+2]==0)
			&&(Map[y-1][x+2]==2||Map[y-1][x+2]==0)
			&&(Map[y][x+2]==2||Map[y][x+2]==0)
			&&(Map[y][x+1]==2||Map[y][x+1]==0))
		{
			Map[y-1][x+1]=0;
		}
	}

	if(Map[y][x+1]==2)
	{
		if((Map[y-1][x]==2||Map[y-1][x]==0)
			&&(Map[y-1][x+1]==2||Map[y-1][x+1]==0)
			&&(Map[y-1][x+2]==2||Map[y-1][x+2]==0)
			&&(Map[y][x+2]==2||Map[y][x+2]==0)
			&&(Map[y+1][x+2]==2||Map[y+1][x+2]==0)
			&&(Map[y+1][x+1]==2||Map[y+1][x+1]==0)
			&&(Map[y+1][x]==2||Map[y+1][x]==0))
		{
			Map[y][x+1]=0;
		}
	}

	if(Map[y+1][x+1]==2)
	{
		if((Map[y][x+1]==2||Map[y][x+1]==0)
			&&(Map[y][x+2]==2||Map[y][x+2]==0)
			&&(Map[y+1][x+2]==2||Map[y+1][x+2]==0)
			&&(Map[y+2][x+2]==2||Map[y+2][x+2]==0)
			&&(Map[y+2][x+1]==2||Map[y+2][x+1]==0)
			&&(Map[y+2][x]==2||Map[y+2][x]==0)
			&&(Map[y+1][x]==2||Map[y+1][x]==0))
		{
			Map[y+1][x+1]=0;
		}
	}

	if(Map[y+1][x]==2)
	{
		if((Map[y][x+1]==2||Map[y][x+1]==0)
			&&(Map[y+1][x+1]==2||Map[y+1][x+1]==0)
			&&(Map[y+2][x+1]==2||Map[y+2][x+1]==0)
			&&(Map[y+2][x]==2||Map[y+2][x]==0)
			&&(Map[y+2][x-1]==2||Map[y+2][x-1]==0)
			&&(Map[y+1][x-1]==2||Map[y+1][x-1]==0)
			&&(Map[y][x-1]==2||Map[y][x-1]==0))
		{
			Map[y+1][x]=0;
		}
	}

	if(Map[y+1][x-1]==2)
	{
		if((Map[y+1][x]==2||Map[y+1][x]==0)
			&&(Map[y+2][x]==2||Map[y+2][x]==0)
			&&(Map[y+2][x-1]==2||Map[y+2][x-1]==0)
			&&(Map[y+2][x-2]==2||Map[y+2][x-2]==0)
			&&(Map[y+1][x-2]==2||Map[y+1][x-2]==0)
			&&(Map[y][x-2]==2||Map[y][x-2]==0)
			&&(Map[y][x-1]==2||Map[y][x-1]==0))
		{
			Map[y+1][x-1]=0;
		}
	}

	if(Map[y][x-1]==2)
	{
		if((Map[y+1][x]==2||Map[y+1][x]==0)
			&&(Map[y+1][x-1]==2||Map[y+1][x-1]==0)
			&&(Map[y+1][x-2]==2||Map[y+1][x-2]==0)
			&&(Map[y][x-2]==2||Map[y][x-2]==0)
			&&(Map[y-1][x-2]==2||Map[y-1][x-2]==0)
			&&(Map[y-1][x-1]==2||Map[y-1][x-1]==0)
			&&(Map[y-1][x]==2||Map[y-1][x]==0))
		{
			Map[y][x-1]=0;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: Update_MAP()
//  Date: 14/11/98
//  Description: Met  jour la MAP avec les informations du robot
//////////////////////////////////////////////////////////////////////////////
void Update_MAP(int Infra_Droite, int Infra_Gauche){

	int pos_X, pos_Y;

		Sem_Position.Lock();
		pos_X = Robot_X;
		pos_Y = Robot_Y;
		Sem_Position.Unlock();

		pos_X++;
		pos_Y++;
	switch(m_Dir_Pas)
	{
		case 1:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y-1][pos_X]==3) Efface_Obstacle(pos_Y-1, pos_X);
				//Pas d'obstacle  gauche
				if(Map[pos_Y-1][pos_X-1]==3) Efface_Obstacle(pos_Y-1, pos_X-1);
				//Pas d'obstacle  droite
				if(Map[pos_Y-1][pos_X+1]==3) Efface_Obstacle(pos_Y-1, pos_X+1);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y-1][pos_X]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y-1][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X-1);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y-1][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X+1);
			}
		break;
		case 2:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y-1][pos_X+1]==3) Efface_Obstacle(pos_Y-1, pos_X+1);
				//Pas d'obstacle  gauche
				if(Map[pos_Y-1][pos_X]==3) Efface_Obstacle(pos_Y-1, pos_X);
				//Pas d'obstacle  droite
				if(Map[pos_Y][pos_X+1]==3) Efface_Obstacle(pos_Y, pos_X+1);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y-1][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X+1);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y-1][pos_X]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y,pos_X+1);
			}
		break;
		case 3:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y][pos_X+1]==3) Efface_Obstacle(pos_Y, pos_X+1);
				//Pas d'obstacle  gauche
				if(Map[pos_Y-1][pos_X+1]==3) Efface_Obstacle(pos_Y-1, pos_X+1);
				//Pas d'obstacle  droite
				if(Map[pos_Y+1][pos_X+1]==3) Efface_Obstacle(pos_Y+1, pos_X+1);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y,pos_X+1);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y-1][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X+1);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y+1][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X+1);
			}
		break;
		case 4:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y+1][pos_X+1]==3) Efface_Obstacle(pos_Y+1, pos_X+1);
				//Pas d'obstacle  gauche
				if(Map[pos_Y][pos_X+1]==3) Efface_Obstacle(pos_Y, pos_X+1);
				//Pas d'obstacle  droite
				if(Map[pos_Y+1][pos_X]==3) Efface_Obstacle(pos_Y+1, pos_X);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y+1][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X+1);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y,pos_X+1);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y+1][pos_X]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X);
			}
		break;
		case 5:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y+1][pos_X]==3) Efface_Obstacle(pos_Y+1, pos_X);
				//Pas d'obstacle  gauche
				if(Map[pos_Y+1][pos_X+1]==3) Efface_Obstacle(pos_Y+1, pos_X+1);
				//Pas d'obstacle  droite
				if(Map[pos_Y+1][pos_X-1]==3) Efface_Obstacle(pos_Y+1, pos_X-1);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y+1][pos_X]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y+1][pos_X+1]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X+1);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y+1][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X-1);
			}
		break;
		case 6:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y+1][pos_X-1]==3) Efface_Obstacle(pos_Y+1, pos_X-1);
				//Pas d'obstacle  gauche
				if(Map[pos_Y+1][pos_X]==3) Efface_Obstacle(pos_Y+1, pos_X);
				//Pas d'obstacle  droite
				if(Map[pos_Y][pos_X-1]==3) Efface_Obstacle(pos_Y, pos_X-1);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y+1][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X-1);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y+1][pos_X]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y,pos_X-1);
			}
		break;
		case 7:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y][pos_X-1]==3) Efface_Obstacle(pos_Y, pos_X-1);
				//Pas d'obstacle  gauche
				if(Map[pos_Y+1][pos_X-1]==3) Efface_Obstacle(pos_Y+1, pos_X-1);
				//Pas d'obstacle  droite
				if(Map[pos_Y-1][pos_X-1]==3) Efface_Obstacle(pos_Y-1, pos_X-1);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y,pos_X-1);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y+1][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y+1,pos_X-1);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y-1][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X-1);
			}
		break;
		case 8:
			if(Infra_Droite == 0 && Infra_Gauche == 0)
			{
				//Pas d'obstacle en avant
				if(Map[pos_Y-1][pos_X-1]==3) Efface_Obstacle(pos_Y-1, pos_X-1);
				//Pas d'obstacle  gauche
				if(Map[pos_Y][pos_X-1]==3) Efface_Obstacle(pos_Y, pos_X-1);
				//Pas d'obstacle  droite
				if(Map[pos_Y-1][pos_X]==3) Efface_Obstacle(pos_Y-1, pos_X);			
			}
			else
			{
				//Obstacle en avant
				if(Infra_Droite == 1 && Infra_Gauche == 1 && Map[pos_Y-1][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X-1);
				//Obstacle  gauche
				if(Infra_Droite == 0 && Infra_Gauche == 1 && Map[pos_Y][pos_X-1]!=3)
					Ajouter_Obstacle(pos_Y,pos_X-1);
				//Obstacle  droite
				if(Infra_Droite == 1 && Infra_Gauche == 0 && Map[pos_Y-1][pos_X]!=3)
					Ajouter_Obstacle(pos_Y-1,pos_X);
			}
		break;


	}

	//Redessine la Map seulement s'il y a des changements
		if(flag_changement==1)
		{

		cMap->ShowMap();
		flag_changement=0;
		}

}


//////////////////////////////////////////////////////////////////////////////
//  Auteur: Sbastien Pouliot
//  Fonction: delais()
//  Date: 29/11/98
//  Description: transfome les dlais en temps
//////////////////////////////////////////////////////////////////////////////
long delais (short bipa , short bipb , int overflow)
{	
long delais;
int ba,bb;
bb = (int)(bipb + 32767);
ba = (int)(bipa + 32767);
delais = (long)(65535 - ba +bb);
return delais;

}

