#include <iostream.h>
#include "MonceauBin.hpp"
#include "Liste.hpp"

//Class qui contient le poids, la position X et Y de chaque point de la map
class Point{
	public:
	int Poids;
	int Direction;
	int X;
	int Y;
};

CPoint Target;
CPoint Cop;
CPoint Bandit;
int Bandit_dir;
BOOL grid = FALSE;

#define dimension			20			//Dimension de la Map(nombre de case par ligne)
#define POIDS_DROITE		10				
#define POIDS_DIAGONALE		14
#define ODOm_Passe_x		1			//Odomtrie en X
#define ODOm_Passe_y		1			//Odomtrie en Y

#ifndef CHEMIN_FLAG
#define CHMEMIN_FLAG

//Variable Global
	int		Chemin[dimension][dimension];	   //Tableau contenant les chemins
	int		Map[dimension+2][dimension+2];

	//Variable Normalis (C'est a dire entiere, trouver en divant par dimension)

	
	int     Robot_Vitesse_G = 0;			       //Vitesse de la Roue Gauche du Robot
	int     Robot_Vitesse_D = 0;                   //Vitesse de la Roue Droite du Robot
	int     Robot_X = 0;						   //Position X du robot
	int		Robot_Y = 0;						   //Position Y du robot
	int     Robot_Arrive_X = 0;						   //Position d'arrive X
	int     Robot_Arrive_Y = 0;						   //Position d'arrive Y	
	int     Robot_Stop	   = 1;                   //Stop la thread (0 = Stop)
	Liste<Point>  Robot_Chemin;						//Chemin du Robot

	//Semaphore
	CSemaphore    Sem_Vitesse;					//Semaphore pour les vitesse
	CSemaphore    Sem_Position;					//Semaphore pour la position du robt
	CSemaphore    Sem_Arrive;					//Semaphore pour la position d'arrivee
	CSemaphore    Sem_Liste;					//Semaphore pour la liste du chemin

	int     m_Vitesse_g = 0;				   //Vitesse Gauche
	int     m_Vitesse_d = 0;					//Vitesse Droite
	int     m_Passe_x	= 0;					//Point X  
	int     m_Passe_y	= 0;					//Point Y  


	int     m_Depart_x  = 0; 				//Nouveau Point de dpart en X
	int     m_Depart_y  = 0;				//Nouveau Point de dpart en Y
	int     m_Arrive_x  = 0;	    		//Point d'arrive en X
	int     m_Arrive_y  = 0;                //Point d'arrive en Y
	int     m_Dir_Fut   = 0;                //Direction Future du Robot
	int     m_Dir_Pre   = 0;                //Direction Present du Robot
	int     m_Dir_Pas   = 0;                //Direction Pass Robot
	int		m_Odo_x		= 0;				//Odomtrie en x	
	int		m_Odo_y     = 0;				//Odomtrie en y	

	double m_Robot_Pre_X,
		   m_Robot_Pre_Y,
		   m_Robot_Pas_X,
		   m_Robot_Pas_Y;

	int flag_changement = 0;
	BOOL firstView = TRUE;					//VRAI lors du premier affichage
	CMapView *cMap;							//Pointeur sur la Map
	int target_flag;						//indique si le target est slectionn
	int bandit_flag;
	int obstacle_flag;
	BOOL Online;
	int flag_showmap = 0;
	BOOL simflag = FALSE;

	short delai1, delai2, delai3, delai4;				//Les temps de reception des bits, pour le calcul de position
	float donnee[3];
	int Robot_Rotation = 0;						//Angle de rotation du robot
	BOOL rotation_flag = FALSE;
	int rayon=100;

#endif