#if !defined(AFX_MAPVIEW_H__0998DAE0_53EE_11D2_B01F_D7277A41B689__INCLUDED_)
#define AFX_MAPVIEW_H__0998DAE0_53EE_11D2_B01F_D7277A41B689__INCLUDED_

#include "Ubiview.h"
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MapView.h : header file
//

extern int bandit_flag;
extern int target_flag;
extern int obstacle_flag;
/////////////////////////////////////////////////////////////////////////////
// CMapView view

class CUBIView;

class CMapView : public CView
{

protected:
      // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMapView)

// Attributes
public:
	CMapView();     
// Operations

public:
	void EffaceSquare(CPoint point);
	void ShowPath(CDC*);
	int angle;
	void ShowCop(CDC*);
	void ShowBandit(CDC *memdc);
	CUBIView* m_ubiView;
	int draw;
	void ShowGrid(CDC*);
	void DrawSquare(CDC*);
	void ShowMap();
	void ShowTarget(CDC*);
	void Reset_Obstacle_Virt();
	void Reset_Obstacle_Reel();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapView)
	protected:
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMapView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CMapView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPVIEW_H__0998DAE0_53EE_11D2_B01F_D7277A41B689__INCLUDED_)
