//////////////////////////////////////////////////////////
// Dfinition du protocole de communication srie 
// pour le PC.
//////////////////////////////////////////////////////////
//#include "wsc.h"

#define LOW_SPEED	30;
#define MED_SPEED	60;
#define HI_SPEED	90;
#define LEFTMOTOR	0;
#define RIGHTMOTOR  1;

class Protocole
{

public:

	void Send_Cmd(char,char,char);
	void Stop();
	void Rotate(int,int);
	void Go(int,int);
	void PrintLCD(char*);
}

void Protocole::Send_Cmd(char cmd,char param1,char param2)
{
	char msg[5];
	char bcc;
	bcc = '$';			// Start byte
	bcc ^= cmd;			// Commande
	bcc ^= param1;		// Paramtre 1
	bcc ^= param2;		// Paramtre 2
	msg[0] = '$';
	msg[1] = cmd;
	msg[2] = param1;
	msg[3] = param2;
	msg[4] = bcc;
	/////////////////////////////
	// Envoie du message
	//SioPuts(0,msg,5);
}

//////////////////////////////////////////////////////////
// Dfinition des commandes 
//////////////////////////////////////////////////////////
/*
Commande:			Value:		Param1:			Param2:
Stop()				0x00		0				0	
Rotate()			0x01		angle			vitesse
Go()				0x02		distance		vitesse
PrintLCD()			0x03		 dterminer	 dterminer
*/

void Protocole::Stop()
{
	Send_Cmd(0x00,0,0);
}

void Protocole::Rotate(int angle, int vitesse)
{
	// L'angle est en degr
	Send_Cmd(0x01,angle,vitesse);
}

void Protocole::Go(int distance,int vitesse)	
{
	Send_Cmd(0x02,distance,vitesse);
}

void Protocole::PrintLCD(char *msg)
{
	int param1, param2;
	Send_Cmd(0x03,param1, param2);
}