/////////////////////////////////////////////////////////////////////////////
// $Id: Erreur.hpp,v 1.3 1997/08/20 02:57:58 parizeau Exp $
//
//   Auteur:       Marc Parizeau
//   Date:         10/4/96
//   Description:  Cette classe permet de gerer des messages d'erreur.
/////////////////////////////////////////////////////////////////////////////

#ifndef ERREUR_HPP_
#define ERREUR_HPP_ 

#include <iostream.h> 

#define ErrBase(Message) Erreur(Message,__FILE__,__LINE__)

/////////////////////////////////////////////////////////////////////////////

class Erreur {

///////////////////// Debut de l'interface publique /////////////////////////
  
public:
  Erreur(char *message="",char *fichier=0,int ligne=0) {
    if(fichier) 
	{
		cerr << "\"" << fichier << "\", ligne " << ligne << ": ";
	}
    cerr << message << endl;
  } 

///////////////////// Fin de l'interface publique //////////////////////////

};

/////////////////////////////////////////////////////////////////////////////

class Exception {

///////////////////// Debut de l'interface publique /////////////////////////
  
 public:
  Exception(char *_message="") {message = _message;}

  void Message() {cerr << message << endl;} 

///////////////////// Fin de l'interface publique //////////////////////////

protected:
  char *message;
   
};

#endif
