// Port.cpp: implementation of the Port class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Port.h"
#include <iostream.h>
#include <fstream.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Port::Port()
{
	
}

Port::~Port()
{

}

/////////////////////////////////////////////////////////////////////
// LoadParam: Lecture de la config du port dans le fichier SCOM.INI
//            et assignements a l'objet de la classe Port.
/////////////////////////////////////////////////////////////////////
int Port::LoadParam()
{
	BOOL empty = TRUE;
	char buf[100];
	ifstream INIfile("scom.ini",ios::in);
	if(!INIfile)
		MessageBox(NULL,"Impossible d'ouvrir le fichier SCOM.INI.","Lecture des paramtres",MB_ICONWARNING);
	INIfile.getline(buf,100);
	while(!INIfile.eof()){
		INIfile.getline(buf,100);
	// LECTURE DES OPTIONS ET ASSIGNEMENT 
		if(strcmp(buf,"[OPTIONS]") == 0) 
		{	
			empty = FALSE;
			INIfile.getline(buf,100);
			portID = GetParam(buf);
		}

		// PARAMETRE DU PREMIER PORT
		if(strcmp(buf,"[Port#1]") == 0) 
		{
			INIfile.getline(buf,100);
			baud = GetParam(buf);
		}	
	}
	if(empty)
	{
		portID = 1;
		baud = 1200;
	}
	INIfile.close();
	/*
	************************************
	// LECTURE DES OPTIONS ET ASSIGNEMENT 
	INIfile.getline(buf,100);
	portID = GetParam(buf);

	switch(portID)
	{
		case 1:
		case 2:
		case 3:
		case 4: 	
			while(strcmp(buf,"[Port#1]") != 0)
				INIfile.getline(buf,100);
			break;
		default: {
			MessageBox(NULL,"Le port slectionn ne peut-tre utilis.","Attention",MB_ICONWARNING);
			return 0;
		}
		break;
	}
	/* Assigner les parametres */
	//INIfile.close();
	return 1;
}

////////////////////////////////////////////////////////////////////
// GetParam: Recoit une ligne du fichier .INI et retourne la valeur 
//           numrique associe.
////////////////////////////////////////////////////////////////////
int Port::GetParam(char *buf)
{
	int value = 0;
	int chiffre;
	unsigned int j= 0;
	while(buf[j] != '=' && j <= sizeof(buf))
		j++;

	j++;
	while(j < strlen(buf))
	{
		chiffre = 0;
		if(buf[j] == ' ')
			chiffre = 10;
		if(buf[j] == '0')
			chiffre = 0;
		if(buf[j] == '1')
			chiffre = 1;
		if(buf[j] == '2')
			chiffre = 2;
		if(buf[j] == '3')
			chiffre = 3;
		if(buf[j] == '4')
			chiffre = 4;
		if(buf[j] == '5')
			chiffre = 5;
		if(buf[j] == '6')
			chiffre = 6;
		if(buf[j] == '7')
			chiffre = 7;
		if(buf[j] == '8')
			chiffre = 8;
		if(buf[j] == '9')
			chiffre = 9;
		if(chiffre != 10)
			value = value*10 + chiffre;
		j++;
	}
	return value;
}
